{
  Icon32Ed

  This notice may not be removed from or altered in any source distribution.

  "Author" herein refers to Abduraghman Hendricks (the creator of the Icon32). "Software" refers to all files
  included with Icon32 distribution package.

  Please note that the Author hereby states that this package is provided "as is" and without any express or
  implied warranties, including, but not without limitation, the implied warranties of merchantability and fitness
  for a particular purpose. In other words, the Author accepts no liability for any damage that may result from
  using Icon32.

  Icon32 is distributed as a freeware. You are free to use Icon32 as part of your application for any purpose
  including freeware, commercial and shareware applications, provided an explicit credit is given to the author
  in application's about box and/or accompanying documentation.

  The origin of this software must not be misrepresented; you must not claim your authorship.
  All redistributions must retain the original copyright notice.

}
unit Icon32Ed;

interface

uses PropertyCategories, DesignEditors, DesignIntf;

type
  TIcon32FileStringProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation

uses TypInfo, Icon32, Classes, Controls, Dialogs;

procedure TIcon32FileStringProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
    try
      Filter := '32 bit Icon files|*.ico|All files|*.*';
      DefaultExt := '*.ico';
      FileName := GetStrValue;
      if Execute then
        SetStrValue(FileName);
    finally
      Free;
    end;
end;

function TIcon32FileStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TIcon32FileString), TIcon32, 'Icon32Name', TIcon32FileStringProperty);
end;

end.
