unit Main;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, ComCtrls, SimpleTimer;

type
  TMainForm = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    Button1: TButton;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    SimpleTimer1: TSimpleTimer;
    SimpleTimer2: TSimpleTimer;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

{----------------- Callback methods -------------------}

procedure TimerProc1(AOwner: TComponent); stdcall;
begin
  with (AOwner as TMainForm) do
  begin
    ListBox1.Items.Add('SimpleTimer1');
    ListBox1.ItemIndex := ListBox1.Items.Count -1;
  end;
end;


procedure TimerProc2(AOwner: TComponent); stdcall;
begin
  with (AOwner as TMainForm) do
  begin
    ListBox1.Items.Add('SimpleTimer2');
    ListBox1.ItemIndex := ListBox1.Items.Count -1;
  end;
end;

{--------------------- TMainForm ----------------------}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SimpleTimer1 := TSimpleTimer.Create(Self, @TimerProc1);
  SimpleTimer2 := TSimpleTimer.Create(Self, @TimerProc2);
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SimpleTimer1.Free;
  SimpleTimer2.Free;
end;


procedure TMainForm.Button1Click(Sender: TObject);
begin
  SimpleTimer1.Start(StrToInt(Edit1.Text));
end;


procedure TMainForm.Button2Click(Sender: TObject);
begin
  SimpleTimer2.Start(StrToInt(Edit2.Text));
end;


procedure TMainForm.Button3Click(Sender: TObject);
begin
  SimpleTimer1.Stop;
end;


procedure TMainForm.Button4Click(Sender: TObject);
begin
  SimpleTimer2.Stop;
end;


procedure TMainForm.Button5Click(Sender: TObject);
begin
  ListBox1.Clear;
end;


procedure TMainForm.Button6Click(Sender: TObject);
begin
  Close;
end;

end.
